% computes the BU and TD color constancy 

visual_flag=0;
for ii=1:opts.nImg 
        if(testset(ii))               
            fprintf(1,'Split %d : Processing image number %d\n',split_counter,ii);

            im=read_im_NTSC_SHI(opts,ii);
            illuminant=opts.illuminants(ii,:);
            
            %% bottom-up color constancy
            for(ll=1:num_ll)
                if(ll>1) % apply one of the color constancy methods
                    [yy,xx]=ndgrid(1:size(im,1),1:size(im,2));
                    mask_square = 1- (xx<opts.mask(ii,1) | xx>opts.mask(ii,3) | yy<opts.mask(ii,2) | yy>opts.mask(ii,4) );
                    [white_R ,white_G ,white_B,im2] = general_cc(im,NN(ll),PP(ll),SS(ll),mask_square);
                    Eilluminant=[white_R,white_G,white_B];
                else  % no color constancy, hypothesis being that the illuminant in the scene is white.
                    im2=im;
                    Eilluminant=[1,1,1]/sqrt(3);
                end                            
                Eilluminant=Eilluminant/norm(Eilluminant);
                errors(ii,ll)=acos(Eilluminant*illuminant');    % error of estimation        
                illuminant_est(ii,ll,:)=Eilluminant;            % store illuminant estimation
             
                [RGB,sift,locations]=compute_features_cc(opts,im2,ii);
                shape_id=features2voc(sift,vocS);
                color_id=features2voc(RGB,vocC);
                pos_id=ceil(locations(:,2)/size(im,1)*Npos)+floor(locations(:,1)/size(im,2)*Npos)*Npos;

                if(ll==1)   % these will be used to cast top-down hypotheses
                    BU_S=shape_id;              
                    BU_P=pos_id;
                end

                wtP=P_distU(:,pos_id)';
                wtS=S_distU(:,shape_id)';
                wtC=C_distU(:,color_id)';

                [wt,td,E,PPP] = plsa2(wtS+eps,wtC+eps,wtP+eps,.00001,0,0);  
                likelihood_I(ii,ll)=E;                          % store likelihood of BU hypotheses
            end        

            %% top-down color constancy
            [TDhyp,HypIm] = TDhypothesis_cc(opts,ii,BU_S,BU_P,S_distU,P_distU,RGB_topics,number_of_topics,locations);
            td_errors= acos(TDhyp*opts.illuminants(ii,:)');     % compute errors of estimation
            numTD=size(TDhyp,1);                                % number of top-down hypotheses            
            for jj=1:numTD
                im=read_im_NTSC_SHI(opts,ii);
                im2=change_illuminant(im,TDhyp(jj,1),TDhyp(jj,2),TDhyp(jj,3),1,0);        

                [RGB,sift,locations]=compute_features_cc(opts,im2,ii);  
                shape_id=features2voc(sift,vocS);
                color_id=features2voc(RGB,vocC); 
                pos_id=ceil(locations(:,2)/size(im,1)*Npos)+floor(locations(:,1)/size(im,2)*Npos)*Npos;

                wtP=P_distU(:,pos_id)';
                wtS=S_distU(:,shape_id)';
                wtC=C_distU(:,color_id)';

                [wt,td,E,PPP] = plsa2(wtS+eps,wtC+eps,wtP+eps,.00001,0,0); 
                likelihood_I(ii,num_ll+jj)=E;                   % store likelihood of TD hypotheses
            end
            
            % select the most likely BU hypotheses and copy its error, and illuminant estimation            
            [max1,max2]=max(likelihood_I(ii,1:num_ll));                              
            errors(ii,num_ll+2)=errors(ii,max2);                                     
            illuminant_est(ii,num_ll+2,:)=illuminant_est(ii,max2,:);

            % select the most likely TD hypotheses and copy its error, and illuminant estimation                        
            [max3,max2]=max(likelihood_I(ii,num_ll+1:num_ll+numTD));                 % best TD
            errors(ii,num_ll+3)=td_errors(max2);                
            illuminant_est(ii,num_ll+3,:)=TDhyp(max2,:);                
            
            % select the most likely BU or TD method and copy its error, and illuminant estimation                                     
            if(max3>max1) %TD>BU
                errors(ii,num_ll+4)=errors(ii,num_ll+3);
                illuminant_est(ii,num_ll+4,:)=illuminant_est(ii,num_ll+3,:);                     
            else          %BU>TD    
                errors(ii,num_ll+4)=errors(ii,num_ll+2);
                illuminant_est(ii,num_ll+4,:)=illuminant_est(ii,num_ll+2,:);
            end
            errors(ii,:)
            likelihood_I(ii,:)                        
        end
end