% computes the average RGB values for each topic. These will be used to generate top-down hypotheses
RGB_topics=zeros(number_of_topics,3);

for ii=1:opts.nImg
        if(trainset(ii))
            fprintf(1,'Processing image number %d\n',ii);
            im=read_im_NTSC_SHI(opts,ii);
            im2=change_illuminant(im,opts.illuminants(ii,1),opts.illuminants(ii,2),opts.illuminants(ii,3),1,0);        % convert illuminant to white lighting
            
            % compute patch colors            
            im3=color_gauss(im2,8);                         
            RR=im3(:,:,1);GG=im3(:,:,2);BB=im3(:,:,3);

            pos2=listL{ii};
            pos3=(pos2(:,1)-1)*size(im,1)+pos2(:,2);
            Rpatch=RR(pos3); Gpatch=GG(pos3); Bpatch=BB(pos3);
            
            wtS=S_distU(:,listS{ii})';
            wtC=C_distU(:,listC{ii})';
            wtP=P_distU(:,listP{ii})';
                        
            [wt,td,E,PPP] = plsa2(wtS+eps,wtC+eps,wtP+eps,.00001,0,0);           
            [max1,max2]=max((wtP.*wtS.*wtC).*(ones(size(wtC,1),1)*td'),[],2);
            
            dist=hist(max2,(1:number_of_topics));
            dist=dist/sum(dist);
            
            for(rr=1:number_of_topics)
                if(dist(rr)>0)
                    maskC=(max2==rr);
                    RGB_topics(rr,:)=RGB_topics(rr,:)+[sum(Rpatch(maskC)),sum(Gpatch(maskC)),sum(Bpatch(maskC))];                    
                end
            end
        end
end

RGB_topics=RGB_topics./(sum(RGB_topics,2)*ones(1,3)+eps);
