% computes unsupervised topics for each of the splits (images not in split are its training set)
% for the unsupervised learning only the shape is taken into account (this was found to improve results)
% this version splits the train and test set according to the sequences (no train and test images should come from the same sequence).

NP=Npos*Npos;                           % number of position bins
shape_id2=[];color_id2=[];pos_id2=[];

counter=0;
for jj=1:opts.nImg
    if(trainset(jj))
        counter=counter+1;
        shape_id2{counter}=listS{jj};
        color_id2{counter}=listC{jj};
        pos_id2{counter}=listP{jj};           
    end
end
[wtS,wtC,wtP,td,E] =plsa_onlyS(shape_id2,color_id2,pos_id2,number_of_topics,.00001,NS,NC,NP,1,1);

P_distU=normalize(wtP',2);
C_distU=normalize(wtC',2);
S_distU=normalize(wtS',2);
SMOOTH=.01; % to prevent zero probabilities

P_distU=normalize(P_distU+1/size(P_distU,2)*SMOOTH,2);
C_distU=normalize(C_distU+1/size(C_distU,2)*SMOOTH,2);
S_distU=normalize(S_distU+1/size(S_distU,2)*SMOOTH,2);

RGBtopics_cc % compute color of topics, needed for Top-Down color constancy

save(sprintf('%s/S_distU%d.mat',opts.datapath,split_counter),'S_distU');
save(sprintf('%s/P_distU%d.mat',opts.datapath,split_counter),'P_distU');
save(sprintf('%s/C_distU%d.mat',opts.datapath,split_counter),'C_distU');
save(sprintf('%s/RGBtopics%d.mat',opts.datapath,split_counter),'RGB_topics');    
